unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls;

type
  TForm1 = class(TForm)
    in1: TShape;
    in2: TShape;
    in3: TShape;
    in4: TShape;
    in5: TShape;
    in6: TShape;
    in7: TShape;
    in8: TShape;
    in9: TShape;
    in10: TShape;
    in11: TShape;
    in12: TShape;
    m1: TShape;
    m4: TShape;
    m2: TShape;
    m3: TShape;
    m5: TShape;
    m7: TShape;
    m6: TShape;
    pers: TShape;
    Shape21: TShape;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  cont:integer=0;
  velocidade:integer=10;
  v:integer=1;
  HookTeclado: HHook;
  velocidadepers:integer=10;


function FuncaoHook(Code: Integer; WordParam: Word; LongParam: LongInt): LongInt; stdcall;


implementation

{$R *.dfm}

procedure TForm1.Timer1Timer(Sender: TObject);
var
i:integer;
objeto:TShape;
rect:TRect;
begin

for i:=1 to 7 do
begin

objeto := TShape(FindComponent('m'+inttostr(i)));

if Assigned(objeto) then
if objeto.Visible then
if IntersectRect(rect,objeto.BoundsRect,pers.BoundsRect) then //Coliso entre os itens
begin
objeto.Hide;
Inc(cont); //Aumenta 1 ponto
end;

end;

for i:=1 to 12 do
begin

objeto := TShape(FindComponent('in'+inttostr(i)));

if Assigned(objeto) then
if IntersectRect(rect,objeto.BoundsRect,pers.BoundsRect) then //Coliso entre os inimigos e o personagem
begin

Timer1.Enabled := False;
Timer2.Enabled := False;
ShowMessage('Voc perdeu!');

end;

end;

if cont = 7 then //Se pegou todas as moedas, ento:
begin

Timer1.Enabled := False;
Timer2.Enabled := False;
ShowMessage('Voc ganhou!');

end;

end;

procedure TForm1.Timer2Timer(Sender: TObject);
var
i:integer;
objeto:TShape;
begin

for i:=1 to 12 do
begin

objeto := TShape(FindComponent('in'+inttostr(i)));

if Assigned(objeto) then
begin

if ((i <= 5) and (Odd(i))) or ((i > 6) and (not Odd(i))) then
begin
objeto.Top := objeto.Top+velocidade*v;
end
else
begin
objeto.Top := objeto.Top-velocidade*v;
end;

if (i=12) and (objeto.Top > 196) then
v := -v;
if (i=12) and (objeto.Top <= 8) then
v := -v;

end;

end;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
HookTeclado:=SetWindowsHookEx(WH_KEYBOARD, @ FuncaoHook, HInstance, GetCurrentThreadId()) ;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
UnHookWindowsHookEx(HookTeclado);
end;




function FuncaoHook(Code: Integer; WordParam: Word; LongParam: LongInt) : LongInt;
var
i:integer;
objeto:TShape;
 begin
case WordParam of
 vk_Space:
begin

// A barra de espao ser responsvel por randomizar as moedas:

cont := 0;
for i:=1 to 7 do
begin
Randomize;
objeto := TShape(Form1.FindComponent('m'+inttostr(i)));
if Assigned(objeto) then
begin
objeto.Show;
objeto.Top := Random(Form1.ClientHeight);
objeto.Left := Random(Form1.ClientWidth);
end;
end;
end;

vk_Right: Form1.pers.Left := Form1.pers.Left+velocidadepers;
vk_Left: Form1.pers.Left := Form1.pers.Left- velocidadepers;
 vk_Up: Form1.pers.Top := Form1.pers.Top- velocidadepers;
 vk_Down: Form1.pers.Top := Form1.pers.Top+ velocidadepers ;
vk_Subtract: velocidade:=Abs(velocidade-1);
vk_Add: velocidade := Abs(velocidade+1);

end;
Result:=0;
end;




end.
